{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "DatatourismeWebAppBundle::modal.html.twig" %}

{% block header %}
    <h4 class="modal-title">{{ "label.visual_editor" | trans }}</h4>
{% endblock %}

{% block modal_class %}modal-fh{% endblock %}
{% block modal_dialog_class %}modal-xl vqe-offcanvas-container{% endblock %}
{% block modal_body_class %}p-0{% endblock %}

{% block body %}
    <div id="visual-query-editor-app" class="p-10">
        <visual-query-editor ng-model="query" query="sparql" mode="sparql">
            <div class="blankslate blankslate-xspacious blankslate-spinner">
                <h4>{{ "text.visual_editor_loading" | trans }}</h4>
            </div>
        </visual-query-editor>
    </div>
{% endblock %}

{% block footer %}
    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">{{ "btn.cancel" | trans }}</button>
    <button type="button" class="btn btn-primary" id="input-submit">{{ "btn.save_query" | trans }}</button>
{% endblock %}

{% block javascripts %}
    <script type="text/javascript">
        var container = $("#visual-query-editor-app");
        var modal = container.parents(".modal");

        // initialize app
        var app = angular.module('visual-query-editor-app')
            .run(function($rootScope, $http) {
                $rootScope.query = {{ flux.queryData | json_encode | raw}};
                $rootScope.sparql = null;
            });

        app.config(function(graphqlClientProvider, $translateProvider) {
            graphqlClientProvider.setEndpoint("{{ path("api.graphql") }}");
            $translateProvider.preferredLanguage('{{ app.request.locale }}');
        });

        // load ontology
        $.get('{{ path("api.ontology") }}', function(data) {
            var ontology = Ontology.fromJson(data);
            app.config(['ontologyProvider', function(ontologyProvider) {
                ontologyProvider.setOntology(ontology);
            }]);
            // bootstrap
            angular.bootstrap(container, ['visual-query-editor-app']);
        }).fail(function(response) {
            $.notify({message: response.responseJSON ? response.responseJSON.error.message : "{{ 'msg.server_error' | trans }}"}, {type:"danger"});
            modal.modal("hide");
        });

        /**
         * input submit
         */
        $("#input-submit", modal).click(function() {
           $(modal).addClass("modal-loading");
           var scope = angular.element(container).scope();
           $.ajax({
               type: 'POST',
               url: "{{ path('flux.editor.visual', {id: flux.id}) }}",
               contentType: 'application/json',
               data: JSON.stringify({
                   query: scope.query,
                   sparql: scope.sparql
               }),
               success: function(response) {
                   modal.on('hidden.bs.modal', function () {
                       window.location.href = response.redirect;
                   });
                   modal.modal("hide");
               },
               error: function(response) {
                   $.notify(response.responseJSON ? response.responseJSON.error.message : "{{ 'msg.server_error' | trans }}",
                       {type: "danger", element: '.modal-body', offset: {y: 20, x: 20}}
                   );
                   $(modal).removeClass("modal-loading");
               }
           });
        });
    </script>
{% endblock %}